
/*------------------------------------------------------------------------
    File        : ExchangeAppt.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Thu Feb 27 18:46:41 EST 2014
    Notes       : Needs Microsoft Exchange Web Services Managed API 2.1
                  or later
                  Note that this is an API to a Web Service. It's possible
                  to do all of this and more "by hand".
  ----------------------------------------------------------------------*/
USING System.*.
USING Microsoft.Exchange.WebServices.Data.*.

DEFINE VARIABLE service        AS ExchangeService. 
DEFINE VARIABLE Body           AS MessageBody.
DEFINE VARIABLE appt           AS Appointment. 
DEFINE VARIABLE ApptStart      AS DATETIME.
DEFINE VARIABLE ApptEnd        AS DATETIME.
DEFINE VARIABLE Url            AS Uri.
DEFINE VARIABLE SecretPassword AS CHARACTER.

/* Get a value from the registry */
SecretPassword = Microsoft.Win32.Registry:GetValue(
"HKEY_CURRENT_USER\Software\PugChallenge",
"SecretPassword","").

apptStart = NOW.
apptEnd = NOW + 3600000. /* One hour later */

Url = NEW Uri("https://outlook.office365.com/EWS/Exchange.asmx").

service = NEW ExchangeService(ExchangeVersion:Exchange2013_SP1) .
/*service:UseDefaultCredentials = TRUE.*/
service:credentials = NEW WebCredentials("tom.bergman@wolterskluwer.com", SecretPassword).
/*service:credentials = NEW WebCredentials(System.Net.CredentialCache:DefaultNetworkCredentials).*/
/* Autodiscover is slow, better to set it manually */

/* AutoDiscoverUrl only works when you host the Exchange server. 
   It will not work with Office365 */
/*service:AutodiscoverUrl("tom.bergman@wolterskluwer.com").*/
service:Url = Url.

Body = NEW MessageBody().
appt = NEW Appointment(service).
Body:BodyType = BodyType:HTML.
Body:Text = "My test <B>New Test appt</B>".

appt:Subject = "Test Subject".
appt:Body = Body.
appt:Start = ApptStart.
appt:End = ApptEnd.

appt:Save().

MESSAGE "done"
    VIEW-AS ALERT-BOX.