
USING System.Diagnostics.*.
USING System.Net.Http.*.
USING System.Collections.Generic.*.

DEFINE VARIABLE Address     AS CHARACTER.
DEFINE VARIABLE Client      AS HttpClient.
DEFINE VARIABLE ResultBytes AS "System.Byte[]".
DEFINE VARIABLE QueryItems  AS "Dictionary<character, character>".
DEFINE VARIABLE AddressUri  AS System.Uri.
DEFINE VARIABLE Url         AS CHARACTER.


Address = "700 Elm Street Manchester, New Hampshire 03101".
/* Use a .Net Dictionary to build a query string */
QueryItems = NEW "Dictionary<character, character>"().
QueryItems:Add("center", Address).
QueryItems:Add("zoom", "18").
QueryItems:Add("size", "800x800").
QueryItems:Add("sensor", "false").
QueryItems:Add("maptype", "hybrid").

Client = NEW HttpClient().

URL = "http://maps.googleapis.com/maps/api/staticmap?" +
  NEW FormUrlEncodedContent(QueryItems):ReadAsStringAsync():Result.

ResultBytes = Client:GetByteArrayAsync(URL):Result.

System.IO.File:WriteAllBytes(".\map.png", ResultBytes).

/* Now we'll open the file using the default application */
Process:Start(".\map.png").


