/* Microsoft AdventureWorks DB needs to be installed to run this demo */

USING System.Data.SqlClient.*.
USING System.Data.*.

DEFINE VARIABLE i         AS INTEGER. 
DEFINE VARIABLE SQL       AS CHARACTER.
DEFINE VARIABLE hq        AS HANDLE.
DEFINE VARIABLE hbuff        AS HANDLE.

DEFINE VARIABLE ConString AS CHARACTER     NO-UNDO.
DEFINE VARIABLE Conn      AS SqlConnection.
DEFINE VARIABLE Cmd       AS SqlCommand.
DEFINE VARIABLE Rdr       AS SqlDataReader.

DEFINE TEMP-TABLE ttPerson 
  FIELD firstName       AS CHARACTER
  FIELD lastName        AS CHARACTER
  FIELD addressline1    AS CHARACTER
  FIELD addressline2    AS CHARACTER
  FIELD City            AS CHARACTER
  FIELD title1          AS CHARACTER
  FIELD middlename      AS CHARACTER
  FIELD suffix          AS CHARACTER
  FIELD stateprovinceid AS INTEGER
  FIELD postalcode      AS CHARACTER.
    
ConString =
  "Server=localhost,1433;" +
  "Database=AdventureWorks2014;" + 
  "Integrated Security=SSPI;".

Conn = NEW SqlConnection(ConString) NO-ERROR. 

SQL = 
  "SELECT Person.Person.Title, Person.Person.FirstName, Person.Person.MiddleName, Person.Person.LastName, Person.Person.Suffix, Person.Address.AddressLine1, " +
  "Person.Address.AddressLine2, Person.Address.City, Person.Address.StateProvinceID, Person.Address.PostalCode " +
  "FROM Person.Address INNER JOIN " +
  "Person.BusinessEntityAddress ON Person.Address.AddressID = Person.BusinessEntityAddress.AddressID INNER JOIN " +
  "Person.BusinessEntity ON Person.BusinessEntityAddress.BusinessEntityID = Person.BusinessEntity.BusinessEntityID INNER JOIN " +
  "Person.Person ON Person.BusinessEntity.BusinessEntityID = Person.Person.BusinessEntityID".

ETIME(TRUE).
Conn:Open().  
Cmd = NEW SqlCommand(Sql, Conn).

Rdr = Cmd:ExecuteReader().

DO WHILE Rdr:Read():
  CREATE ttPerson.
  ASSIGN
    ttPerson.firstname       = Rdr["lastname"]
    ttPerson.lastName        = Rdr["firstname"]
    ttPerson.addressline1    = Rdr["addressline1"]
    ttPerson.addressline2    = Rdr["addressline2"]
    ttPerson.title1          = Rdr["title"]
    ttPerson.suffix          = Rdr["suffix"]
    ttPerson.stateprovinceid = Rdr["stateprovinceid"]
    ttPerson.postalcode      = Rdr["postalcode"]
    ttPerson.middlename      = Rdr["middlename"]
    ttPerson.city            = Rdr["city"].
  i = i + 1. 
END.

MESSAGE ETIME "Milliseonds"SKIP
  i "Temp Table Records created."
  VIEW-AS ALERT-BOX.

hBuff = TEMP-TABLE ttPerson:DEFAULT-BUFFER-HANDLE.
CREATE QUERY hQ.
hQ:SET-BUFFERS(hBuff).
hQ:QUERY-PREPARE("For each " + hBuff:NAME).
hQ:QUERY-OPEN.

DO WHILE hQ:GET-NEXT() WITH FRAME xxx:
  
  DISPLAY
    hBuff:BUFFER-FIELD("FirstName"):buffer-Value
    hBuff:BUFFER-FIELD("LastName"):buffer-Value FORMAT "x(12)"
    hBuff:BUFFER-FIELD("AddressLine1"):buffer-Value FORMAT "x(20)"
    hBuff:BUFFER-FIELD("City"):buffer-Value FORMAT "x(12)"

    WITH FRAME xxx.

END.
MESSAGE hQ:NUM-RESULTS
  VIEW-AS ALERT-BOX.
  





