/* Microsoft AdventureWorks DB needs to be installed to run this demo */

USING System.Data.SqlClient.*.
USING System.Data.*.
USING System.IO.*.

DEFINE VARIABLE i          AS INTEGER. 
DEFINE VARIABLE fieldList  AS CHARACTER.
DEFINE VARIABLE SQL        AS CHARACTER.
DEFINE VARIABLE ConString  AS CHARACTER.
DEFINE VARIABLE ProgressDS AS HANDLE.
DEFINE VARIABLE hQ         AS HANDLE.
DEFINE VARIABLE hBuff      AS HANDLE.
DEFINE VARIABLE vLong      AS LONGCHAR. 

DEFINE VARIABLE DotNetDS   AS DataSet.
DEFINE VARIABLE Conn       AS SqlConnection.
DEFINE VARIABLE Adapter    AS SqlDataAdapter.
DEFINE VARIABLE SR         AS StreamReader.
DEFINE VARIABLE MS         AS MemoryStream.
    
ConString =
  "Server=localhost,1433;" +
  "Database=AdventureWorks2014;" +
  "Integrated Security=SSPI;".

SQL = 
  "SELECT Person.Person.Title, Person.Person.FirstName, Person.Person.MiddleName, Person.Person.LastName, Person.Person.Suffix, Person.Address.AddressLine1, " +
  "Person.Address.AddressLine2, Person.Address.City, Person.Address.StateProvinceID, Person.Address.PostalCode " +
  "FROM Person.Address INNER JOIN " +
  "Person.BusinessEntityAddress ON Person.Address.AddressID = Person.BusinessEntityAddress.AddressID INNER JOIN " +
  "Person.BusinessEntity ON Person.BusinessEntityAddress.BusinessEntityID = Person.BusinessEntity.BusinessEntityID INNER JOIN " +
  "Person.Person ON Person.BusinessEntity.BusinessEntityID = Person.Person.BusinessEntityID".

ETIME(TRUE).


Conn = NEW SqlConnection(ConString) NO-ERROR.
/* Create a SqlAdapter with our SQL statement and connection */     
Adapter = NEW SqlDataAdapter(Sql,Conn).
/* Create a new .Net dataset */
DotNetDS = NEW dataset().
/* Create a new Progress dataset */
CREATE DATASET ProgressDS.    
/* If the fill statement opens the connection, it will close it. 
   If it's already open, it will leave it open.  
   The second parameter, which is optional, will name the table returned.*/
Adapter:Fill(DotNetDS, "ttPerson").
MS = NEW MemoryStream().
/* Put the XML from the .Net dataset into a memory stream. 
   Include schema information */
DotNetDS:WriteXml(MS, XmlWriteMode:WriteSchema).
/* Move memory stream to the beginning */
MS:Position = 0.
/* Open a .Net streamreader for the memorystream */
SR = NEW StreamReader(MS).
/* Put the content into a Progress longchar */
vLong = SR:ReadToEnd(). 
/* Load the Progress dataset from the longchar */
ProgressDS:READ-XML("longchar",vLong,?,?,?).

MESSAGE ETIME "Milliseconds" skip 
  "Records: " DotNetDs:Tables[0]:Rows:Count
  VIEW-AS ALERT-BOX.
/* Build a list of what fields we now have in our dataset */
hBuff = ProgressDS:GET-BUFFER-HANDLE(1).
DO i = 1 TO hBuff:NUM-FIELDS:
  fieldList = fieldList + hBuff:BUFFER-FIELD(i):Name + " - " +
    hBuff:BUFFER-FIELD(i):data-type + "~n".
END.

MESSAGE "Buffer Name: " 
  hBuff:NAME SKIP 
  hBuff:NUM-FIELDS " Fields" SKIP
  fieldList
  VIEW-AS ALERT-BOX.
 
CREATE QUERY hQ.
hQ:SET-BUFFERS(hBuff).
hQ:QUERY-PREPARE("For each " + hBuff:NAME).
hQ:QUERY-OPEN.
DO WHILE hQ:GET-NEXT() WITH FRAME xxx:
  
  DISPLAY
    hBuff:BUFFER-FIELD("FirstName"):buffer-Value
    hBuff:BUFFER-FIELD("LastName"):buffer-Value FORMAT "x(12)"
    hBuff:BUFFER-FIELD("AddressLine1"):buffer-Value FORMAT "x(20)"
    hBuff:BUFFER-FIELD("City"):buffer-Value FORMAT "x(12)"
    WITH FRAME xxx.

END.
MESSAGE hQ:NUM-RESULTS
  VIEW-AS ALERT-BOX.
  



