USING System.Net.*.
USING System.Text.*.
USING System.Diagnostics.*.

DEFINE VARIABLE oClient  AS WebClient.
DEFINE VARIABLE result   AS LONGCHAR.
DEFINE VARIABLE oByte    AS "System.Byte[]".
DEFINE VARIABLE oRequest AS WebRequest.
DEFINE VARIABLE vMem     AS MEMPTR.

oClient = NEW WebClient().

/* This page is filled with UTF-8 characters and is great for testing */
oClient:BaseAddress = "http://www.columbia.edu/~kermit/utf8.html".
/*oClient:BaseAddress = "http://www.utf-8.com/".*/

/* If you expect UTF-8, set the Encoding. The default is the OS encoding 
  (1252 on my PC).  Webclient tries to detect this from the header but I find
  it's rarely correct or useful */
oClient:Encoding = Encoding:UTF8.
/* If -cpinternal not UTF-8, then we need to force this */
IF SESSION:CPINTERNAL NE "UTF-8" THEN
  fix-codepage(result) = "UTF-8".

/* If -cpinternal is not UTF-8, the data will be corrupted as we 
   use DownloadString. Instead, we're getting the data in a Byte Array and 
   converting it */
IF SESSION:CPINTERNAL NE "UTF-8" THEN
DO:
  oByte = oClient:DownloadData("").
  vMem = PUGUtils:ByteArrayToMemptr(oByte).
  COPY-LOB vMem TO Result NO-CONVERT.
  set-size(vMem) = 0.
END.
/* The easy way when -cpinternal = utf-8 */
ELSE
  result = oClient:DownloadString("").  

/* Check this file with a text editor that handles utf-8 and see
   if the data is correct */    
COPY-LOB result TO FILE ".\utf8.txt" NO-CONVERT.
/* Now we'll open the file using the default application */
Process:Start(".\utf8.txt").

