
/*------------------------------------------------------------------------
    File        : ZipDemo.p
    Purpose     : 

    Syntax      : Requires .Net 4.5 or greater

    Description : 

    Author(s)   : 
    Created     : Thu Feb 20 06:53:27 EST 2014
    Notes       : Needs System.IO.Compression and System.IO.Compression.FileSystem 
                  in the assemblies.xml file
  ----------------------------------------------------------------------*/
USING System.IO.Compression.*.
USING System.IO.*.
USING System.Diagnostics.*.

DEFINE VARIABLE oZipFile AS ZipArchive.

/*Init for demo*/
Directory:Delete(".\ZippedFiles",TRUE) NO-ERROR.
Directory:CreateDirectory(".\ZippedFiles").

/* Create a new zip file and zip the content of .\FilesToZip into the file */
ZipFile:CreateFromDirectory(".\FilesToZip",".\ZippedFiles\DirectoryZip.Zip").
/* Extract the newly created file to the .\ZippedFiles folder */
ZipFile:ExtractToDirectory(".\ZippedFiles\DirectoryZip.Zip",".\ZippedFiles").

/* Now we're going to create a zip file and add files to it one at a time */
oZipFile = ZipFile:Open(".\ZippedFiles\FilesZip.Zip", ZipArchiveMode:Create).

ZipFileExtensions:CreateEntryFromFile(oZipFile,".\FilesToZip\MyBmpTest.tiff","MyBmpTest.tiff").
ZipFileExtensions:CreateEntryFromFile(oZipFile,".\FilesToZip\MyBmpTest.bmp","MyBmpTest.bmp").
/* The file won't actually get fully written until Dispose is called */
oZipFile:Dispose().
/* Show the folder content */
Process:Start(".\ZippedFiles").

/* We will look and see what files are in this zip file */
oZipFile = ZipFile:OpenRead(".\ZippedFiles\FilesZip.zip").
{foreach.i ZipArchiveEntry oEntry in oZipFile:Entries} 
  MESSAGE oEntry:FullName
  VIEW-AS ALERT-BOX.
END.